#ifndef SYNTHACT_H
#define SYNTHACT_H

class microSynth
{
public:
    microSynth();
    ~microSynth();
    void isLFO1toVO1(bool);
    void isLFO1toPO1(bool);
    void isLFO1toVO2(bool);
    void isLFO1toPO2(bool);
    void isLFO1toVO3(bool);
    void isLFO1toPO3(bool);
    void isLFO2toVO1(bool);
    void isLFO2toPO1(bool);
    void isLFO2toVO2(bool);
    void isLFO2toPO2(bool);
    void isLFO2toVO3(bool);
    void isLFO2toPO3(bool);
    void isNoteOn(bool, unsigned short int);
    void setLFO1wave(unsigned short int);
    void setLFO2wave(unsigned short int);
    void setOSC1wave(unsigned short int);
    void setOSC2wave(unsigned short int);
    void setOSC3wave(unsigned short int);
    unsigned short int getLFO1wave();
    unsigned short int getLFO2wave();
    unsigned short int getOSC1wave();
    unsigned short int getOSC2wave();
    unsigned short int getOSC3wave();
    void setAmp(unsigned short int);
    float getAmp();
    void setPan(unsigned short int);
    float getPan();
    void setVolOSC1(unsigned short int);
    float getVolOSC1();
    void setPanOSC1(unsigned short int);
    float getPanOSC1();
    void setVolOSC2(unsigned short int);
    float getVolOSC2();
    void setPanOSC2(unsigned short int);
    float getPanOSC2();
    void setVolOSC3(unsigned short int);
    float getVolOSC3();
    void setPanOSC3(unsigned short int);
    float getPanOSC3();
    void setVolLFO1(unsigned short int);
    float getVolLFO1();
    void setFreqLFO1(unsigned short int);
    float getFreqLFO1();
    void setVolLFO2(unsigned short int);
    float getVolLFO2();
    void setFreqLFO2(unsigned short int);
    float getFreqLFO2();
    void setSampleRate(unsigned int);
    unsigned int getSampleRate();
    bool tellMeLFOtoOSC1(unsigned short int, unsigned short int);
    bool tellMeLFOtoOSC2(unsigned short int, unsigned short int);
    bool tellMeLFOtoOSC3(unsigned short int, unsigned short int);
    void setPitch(unsigned short int);
    int getPitch();
    void setControlVol(unsigned short int);
    float getControlVol();
    void setMaxEnvTime(float);
    float getMaxEnvTime();
    void setLatency(unsigned int);
    unsigned int getLatency();
    void setAuralValue(bool);
    float getAuralValue();
    short int noteOnCount;
private:
    bool LFO1toVO1;
    bool LFO1toPO1;
    bool LFO1toVO2;
    bool LFO1toPO2;
    bool LFO1toVO3;
    bool LFO1toPO3;
    bool LFO2toVO1;
    bool LFO2toPO1;
    bool LFO2toVO2;
    bool LFO2toPO2;
    bool LFO2toVO3;
    bool LFO2toPO3;
    unsigned short int waveLFO1;
    unsigned short int waveLFO2;
    unsigned short int waveOSC1;
    unsigned short int waveOSC2;
    unsigned short int waveOSC3;
    float ampValue;
    float panValue;
    float volOSC1;
    float panOSC1;
    float volOSC2;
    float panOSC2;
    float volOSC3;
    float panOSC3;
    float volLFO1;
    float freqLFO1;
    float volLFO2;
    float freqLFO2;
    bool noteOn;
    unsigned short int notePitch;
    unsigned int sample_Rate;
    float controlVol;
    float maxEnvTime;
    unsigned int latency;
    float auralValue;
};

#endif // SYNTHACT_H
